; ====================================================;
;                                                     ;
;     shell32.inc for EC v2 Fasm classic projects     ;
;                   (version 1.0.4)                   ;
;                                                     ;
;         Copyright  Ramon Sala - 2018-2021          ;
;                                                     ;
; ====================================================;

if ~defined SHELL32_INC
define SHELL32_INC 1

ABM_NEW                                         equ     000000000H
ABM_REMOVE                                      equ     000000001H
ABM_QUERYPOS                                    equ     000000002H
ABM_SETPOS                                      equ     000000003H
ABM_GETSTATE                                    equ     000000004H
ABM_GETTASKBARPOS                               equ     000000005H
ABM_ACTIVATE                                    equ     000000006H
ABM_GETAUTOHIDEBAR                              equ     000000007H
ABM_SETAUTOHIDEBAR                              equ     000000008H
ABM_WINDOWPOSCHANGED                            equ     000000009H
ABM_SETSTATE                                    equ     00000000AH
ABM_GETAUTOHIDEBAREX                            equ     00000000BH
ABM_SETAUTOHIDEBAREX                            equ     00000000CH

ABN_STATECHANGE                                 equ     00000000H
ABN_POSCHANGED                                  equ     00000001H
ABN_FULLSCREENAPP                               equ     00000002H
ABN_WINDOWARRANGE                               equ     00000003H

ABS_AUTOHIDE                                    equ     00000001H
ABS_ALWAYSONTOP                                 equ     00000002H

ABE_LEFT                                        equ     0
ABE_TOP                                         equ     1
ABE_RIGHT                                       equ     2
ABE_BOTTOM                                      equ     3

FO_MOVE                                         equ     00001H
FO_COPY                                         equ     00002H
FO_DELETE                                       equ     00003H
FO_RENAME                                       equ     00004H

FOF_MULTIDESTFILES                              equ     00001H
FOF_CONFIRMMOUSE                                equ     00002H
FOF_SILENT                                      equ     00004H
FOF_RENAMEONCOLLISION                           equ     00008H
FOF_NOCONFIRMATION                              equ     00010H
FOF_WANTMAPPINGHANDLE                           equ     00020H

FOF_ALLOWUNDO                                   equ     00040H
FOF_FILESONLY                                   equ     00080H
FOF_SIMPLEPROGRESS                              equ     00100H
FOF_NOCONFIRMMKDIR                              equ     00200H
FOF_NOERRORUI                                   equ     00400H
FOF_NOCOPYSECURITYATTRIBS                       equ     00800H
FOF_NORECURSION                                 equ     01000H
FOF_NO_CONNECTED_ELEMENTS                       equ     02000H
FOF_WANTNUKEWARNING                             equ     04000H
FOF_NORECURSEREPARSE                            equ     08000H
FOF_NO_UI                                       equ     (FOF_SILENT or FOF_NOCONFIRMATION or FOF_NOERRORUI or FOF_NOCONFIRMMKDIR)

PO_DELETE                                       equ     00013H
PO_RENAME                                       equ     00014H
PO_PORTCHANGE                                   equ     00020H
PO_REN_PORT                                     equ     00034H

TYPEDEF                                         FILEOP_FLAGS, dw
TYPEDEF                                         PRINTEROP_FLAGS, dw

SE_ERR_FNF                                      equ     2
SE_ERR_PNF                                      equ     3
SE_ERR_ACCESSDENIED                             equ     5
SE_ERR_OOM                                      equ     8
SE_ERR_SHARE                                    equ     26
SE_ERR_ASSOCINCOMPLETE                          equ     27
SE_ERR_DDETIMEOUT                               equ     28
SE_ERR_DDEFAIL                                  equ     29
SE_ERR_DDEBUSY                                  equ     30
SE_ERR_NOASSOC                                  equ     31
SE_ERR_DLLNOTFOUND                              equ     32

SEE_MASK_DEFAULT                                equ     000000000H
SEE_MASK_CLASSNAME                              equ     000000001H
SEE_MASK_CLASSKEY                               equ     000000003H
SEE_MASK_IDLIST                                 equ     000000004H
SEE_MASK_INVOKEIDLIST                           equ     00000000CH
SEE_MASK_ICON                                   equ     000000010H
SEE_MASK_HOTKEY                                 equ     000000020H
SEE_MASK_NOCLOSEPROCESS                         equ     000000040H
SEE_MASK_CONNECTNETDRV                          equ     000000080H
SEE_MASK_NOASYNC                                equ     000000100H
SEE_MASK_FLAG_DDEWAIT                           equ     SEE_MASK_NOASYNC
SEE_MASK_DOENVSUBST                             equ     000000200H
SEE_MASK_FLAG_NO_UI                             equ     000000400H
SEE_MASK_UNICODE                                equ     000004000H
SEE_MASK_NO_CONSOLE                             equ     000008000H
SEE_MASK_ASYNCOK                                equ     000100000H
SEE_MASK_HMONITOR                               equ     000200000H
SEE_MASK_NOZONECHECKS                           equ     000800000H
SEE_MASK_NOQUERYCLASSSTORE                      equ     001000000H
SEE_MASK_WAITFORINPUTIDLE                       equ     002000000H
SEE_MASK_FLAG_LOG_USAGE                         equ     004000000H
SEE_MASK_FLAG_HINST_IS_SITE                     equ     008000000H

ASSOCCLASS_SHELL_KEY                            equ     0
ASSOCCLASS_PROGID_KEY                           equ     01H
ASSOCCLASS_PROGID_STR                           equ     02H
ASSOCCLASS_CLSID_KEY                            equ     03H
ASSOCCLASS_CLSID_STR                            equ     04H
ASSOCCLASS_APP_KEY                              equ     05H
ASSOCCLASS_APP_STR                              equ     06H
ASSOCCLASS_SYSTEM_STR                           equ     07H
ASSOCCLASS_FOLDER                               equ     08H
ASSOCCLASS_STAR                                 equ     09H
ASSOCCLASS_FIXED_PROGID_STR                     equ     0AH
ASSOCCLASS_PROTOCOL_STR                         equ     0BH

SHERB_NOCONFIRMATION                            equ     000000001H
SHERB_NOPROGRESSUI                              equ     000000002H
SHERB_NOSOUND                                   equ     000000004H

QUNS_NOT_PRESENT                                equ     1
QUNS_BUSY                                       equ     2
QUNS_RUNNING_D3D_FULL_SCREEN                    equ     3
QUNS_PRESENTATION_MODE                          equ     4
QUNS_ACCEPTS_NOTIFICATIONS                      equ     5
QUNS_QUIET_TIME                                 equ     6
QUNS_APP                                        equ     7

NIM_ADD                                         equ     000000000H
NIM_MODIFY                                      equ     000000001H
NIM_DELETE                                      equ     000000002H
NIM_SETFOCUS                                    equ     000000003h
NIM_SETVERSION                                  equ     000000004H

NIN_SELECT                                      equ     (WM_USER + 0)
NINF_KEY                                        equ     01H
NIN_KEYSELECT                                   equ     (NIN_SELECT or NINF_KEY)
NIN_BALLOONSHOW                                 equ     (WM_USER + 2)
NIN_BALLOONHIDE                                 equ     (WM_USER + 3)
NIN_BALLOONTIMEOUT                              equ     (WM_USER + 4)
NIN_BALLOONUSERCLICK                            equ     (WM_USER + 5)
NIN_POPUPOPEN                                   equ     (WM_USER + 6)
NIN_POPUPCLOSE                                  equ     (WM_USER + 7)

NOTIFYICON_VERSION                              equ     3
NOTIFYICON_VERSION_4                            equ     4

NIF_MESSAGE                                     equ     000000001H
NIF_ICON                                        equ     000000002H
NIF_TIP                                         equ     000000004H
NIF_STATE                                       equ     000000008H
NIF_INFO                                        equ     000000010H
NIF_GUID                                        equ     000000020H
NIF_REALTIME                                    equ     000000040H
NIF_SHOWTIP                                     equ     000000080H

NIS_HIDDEN                                      equ     000000001H
NIS_SHAREDICON                                  equ     000000002H

NIIF_NONE                                       equ     000000000H
NIIF_INFO                                       equ     000000001H
NIIF_WARNING                                    equ     000000002H
NIIF_ERROR                                      equ     000000003H
NIIF_USER                                       equ     000000004H
NIIF_ICON_MASK                                  equ     00000000FH
NIIF_NOSOUND                                    equ     000000010H
NIIF_LARGE_ICON                                 equ     000000020H
NIIF_RESPECT_QUIET_TIME                         equ     000000080H

SHARD_PIDL                                      equ     000000001H
SHARD_PATHA                                     equ     000000002H
SHARD_PATHW                                     equ     000000003H
if defined APP_UNICODE
    SHARD_PATH                                  equ     SHARD_PATHW
else
    SHARD_PATH                                  equ     SHARD_PATHA
end if

SHDID_ROOT_REGITEM                              equ     1
SHDID_FS_FILE                                   equ     2
SHDID_FS_DIRECTORY                              equ     3
SHDID_FS_OTHER                                  equ     4
SHDID_COMPUTER_DRIVE35                          equ     5
SHDID_COMPUTER_DRIVE525                         equ     6
SHDID_COMPUTER_REMOVABLE                        equ     7
SHDID_COMPUTER_FIXED                            equ     8
SHDID_COMPUTER_NETDRIVE                         equ     9
SHDID_COMPUTER_CDROM                            equ     10
SHDID_COMPUTER_RAMDISK                          equ     11
SHDID_COMPUTER_OTHER                            equ     12
SHDID_NET_DOMAIN                                equ     13
SHDID_NET_SERVER                                equ     14
SHDID_NET_SHARE                                 equ     15
SHDID_NET_RESTOFNET                             equ     16
SHDID_NET_OTHER                                 equ     17
SHDID_COMPUTER_IMAGING                          equ     18
SHDID_COMPUTER_AUDIO                            equ     19
SHDID_COMPUTER_SHAREDDOCS                       equ     20
SHDID_MOBILE_DEVICE                             equ     21

SHGDFIL_FINDDATA                                equ     1
SHGDFIL_NETRESOURCE                             equ     2
SHGDFIL_DESCRIPTIONID                           equ     3

SHGFI_ICON                                      equ     0000000100H
SHGFI_DISPLAYNAME                               equ     0000000200H
SHGFI_TYPENAME                                  equ     0000000400H
SHGFI_ATTRIBUTES                                equ     0000000800H
SHGFI_ICONLOCATION                              equ     0000001000H
SHGFI_EXETYPE                                   equ     0000002000H
SHGFI_SYSICONINDEX                              equ     0000004000H
SHGFI_LINKOVERLAY                               equ     0000008000H
SHGFI_SELECTED                                  equ     0000010000H
SHGFI_ATTR_SPECIFIED                            equ     0000020000H
SHGFI_LARGEICON                                 equ     0000000000H
SHGFI_SMALLICON                                 equ     0000000001H
SHGFI_OPENICON                                  equ     0000000002H
SHGFI_SHELLICONSIZE                             equ     0000000004H
SHGFI_PIDL                                      equ     0000000008H
SHGFI_USEFILEATTRIBUTES                         equ     0000000010H
SHGFI_ADDOVERLAYS                               equ     0000000020H
SHGFI_OVERLAYINDEX                              equ     0000000040H

SHGSI_ICONLOCATION                              equ     0
SHGSI_ICON                                      equ     SHGFI_ICON
SHGSI_SYSICONINDEX                              equ     SHGFI_SYSICONINDEX
SHGSI_LINKOVERLAY                               equ     SHGFI_LINKOVERLAY
SHGSI_SELECTED                                  equ     SHGFI_SELECTED
SHGSI_LARGEICON                                 equ     SHGFI_LARGEICON
SHGSI_SMALLICON                                 equ     SHGFI_SMALLICON
SHGSI_SHELLICONSIZE                             equ     SHGFI_SHELLICONSIZE

SIID_DOCNOASSOC                                 equ     0
SIID_DOCASSOC                                   equ     1
SIID_APPLICATION                                equ     2
SIID_FOLDER                                     equ     3
SIID_FOLDEROPEN                                 equ     4
SIID_DRIVE525                                   equ     5
SIID_DRIVE35                                    equ     6
SIID_DRIVEREMOVE                                equ     7
SIID_DRIVEFIXED                                 equ     8
SIID_DRIVENET                                   equ     9
SIID_DRIVENETDISABLED                           equ     10
SIID_DRIVECD                                    equ     11
SIID_DRIVERAM                                   equ     12
SIID_WORLD                                      equ     13
SIID_SERVER                                     equ     15
SIID_PRINTER                                    equ     16
SIID_MYNETWORK                                  equ     17
SIID_FIND                                       equ     22
SIID_HELP                                       equ     23
SIID_SHARE                                      equ     28
SIID_LINK                                       equ     29
SIID_SLOWFILE                                   equ     30
SIID_RECYCLER                                   equ     31
SIID_RECYCLERFULL                               equ     32
SIID_MEDIACDAUDIO                               equ     40
SIID_LOCK                                       equ     47
SIID_AUTOLIST                                   equ     49
SIID_PRINTERNET                                 equ     50
SIID_SERVERSHARE                                equ     51
SIID_PRINTERFAX                                 equ     52
SIID_PRINTERFAXNET                              equ     53
SIID_PRINTERFILE                                equ     54
SIID_STACK                                      equ     55
SIID_MEDIASVCD                                  equ     56
SIID_STUFFEDFOLDER                              equ     57
SIID_DRIVEUNKNOWN                               equ     58
SIID_DRIVEDVD                                   equ     59
SIID_MEDIADVD                                   equ     60
SIID_MEDIADVDRAM                                equ     61
SIID_MEDIADVDRW                                 equ     62
SIID_MEDIADVDR                                  equ     63
SIID_MEDIADVDROM                                equ     64
SIID_MEDIACDAUDIOPLUS                           equ     65
SIID_MEDIACDRW                                  equ     66
SIID_MEDIACDR                                   equ     67
SIID_MEDIACDBURN                                equ     68
SIID_MEDIABLANKCD                               equ     69
SIID_MEDIACDROM                                 equ     70
SIID_AUDIOFILES                                 equ     71
SIID_IMAGEFILES                                 equ     72
SIID_VIDEOFILES                                 equ     73
SIID_MIXEDFILES                                 equ     74
SIID_FOLDERBACK                                 equ     75
SIID_FOLDERFRONT                                equ     76
SIID_SHIELD                                     equ     77
SIID_WARNING                                    equ     78
SIID_INFO                                       equ     79
SIID_ERROR                                      equ     80
SIID_KEY                                        equ     81
SIID_SOFTWARE                                   equ     82
SIID_RENAME                                     equ     83
SIID_DELETE                                     equ     84
SIID_MEDIAAUDIODVD                              equ     85
SIID_MEDIAMOVIEDVD                              equ     86
SIID_MEDIAENHANCEDCD                            equ     87
SIID_MEDIAENHANCEDDVD                           equ     88
SIID_MEDIAHDDVD                                 equ     89
SIID_MEDIABLURAY                                equ     90
SIID_MEDIAVCD                                   equ     91
SIID_MEDIADVDPLUSR                              equ     92
SIID_MEDIADVDPLUSRW                             equ     93
SIID_DESKTOPPC                                  equ     94
SIID_MOBILEPC                                   equ     95
SIID_USERS                                      equ     96
SIID_MEDIASMARTMEDIA                            equ     97
SIID_MEDIACOMPACTFLASH                          equ     98
SIID_DEVICECELLPHONE                            equ     99
SIID_DEVICECAMERA                               equ     100
SIID_DEVICEVIDEOCAMERA                          equ     101
SIID_DEVICEAUDIOPLAYER                          equ     102
SIID_NETWORKCONNECT                             equ     103
SIID_INTERNET                                   equ     104
SIID_ZIPFILE                                    equ     105
SIID_SETTINGS                                   equ     106
SIID_DRIVEHDDVD                                 equ     132
SIID_DRIVEBD                                    equ     133
SIID_MEDIAHDDVDROM                              equ     134
SIID_MEDIAHDDVDR                                equ     135
SIID_MEDIAHDDVDRAM                              equ     136
SIID_MEDIABDROM                                 equ     137
SIID_MEDIABDR                                   equ     138
SIID_MEDIABDRE                                  equ     139
SIID_CLUSTEREDDRIVE                             equ     140
SIID_MAX_ICONS                                  equ     175

SIID_INVALID                                    equ     (-1)

SHGNLI_PIDL                                     equ     0000000001H
SHGNLI_PREFIXNAME                               equ     0000000002H
SHGNLI_NOUNIQUE                                 equ     0000000004H
SHGNLI_NOLNK                                    equ     0000000008H
SHGNLI_NOLOCNAME                                equ     0000000010H
SHGNLI_USEURLEXT                                equ     0000000020H

PRINTACTION_OPEN                                equ     0
PRINTACTION_PROPERTIES                          equ     1
PRINTACTION_NETINSTALL                          equ     2
PRINTACTION_NETINSTALLLINK                      equ     3
PRINTACTION_TESTPAGE                            equ     4
PRINTACTION_OPENNETPRN                          equ     5
PRINTACTION_DOCUMENTDEFAULTS                    equ     6
PRINTACTION_SERVERPROPERTIES                    equ     7

OFFLINE_STATUS_LOCAL                            equ     00001H
OFFLINE_STATUS_REMOTE                           equ     00002H
OFFLINE_STATUS_INCOMPLETE                       equ     00004H

SHIL_LARGE                                      equ     0
SHIL_SMALL                                      equ     1
SHIL_EXTRALARGE                                 equ     2
SHIL_SYSSMALL                                   equ     3
if (NTDDI_VERSION >= NTDDI_VISTA)
    SHIL_JUMBO                                  equ     4
    SHIL_LAST                                   equ     SHIL_JUMBO
else
    SHIL_LAST                                   equ     SHIL_SYSSMALL
end if

WC_NETADDRESS                                   equ     du "msctls_netaddress", 0

NCM_SETALLOWTYPE                                equ     (WM_USER + 2)
NCM_GETALLOWTYPE                                equ     (WM_USER + 3)
NCM_DISPLAYERRORTIP                             equ     (WM_USER + 4)

SCNRT_ENABLE                                    equ     0
SCNRT_DISABLE                                   equ     1

GPFIDL_DEFAULT                                  equ     00000H
GPFIDL_ALTNAME                                  equ     00001H
GPFIDL_UNCPRINTER                               equ     00002H

SIGDN_NORMALDISPLAY                             equ     00000000H
SIGDN_PARENTRELATIVEPARSING                     equ     80018001H
SIGDN_DESKTOPABSOLUTEPARSING                    equ     80028000H
SIGDN_PARENTRELATIVEEDITING                     equ     80031001H
SIGDN_DESKTOPABSOLUTEEDITING                    equ     8004c000H
SIGDN_FILESYSPATH                               equ     80058000H
SIGDN_URL                                       equ     80068000H
SIGDN_PARENTRELATIVEFORADDRESSBAR               equ     8007C001H
SIGDN_PARENTRELATIVE                            equ     80080001H
SIGDN_PARENTRELATIVEFORUI                       equ     80094001H

GPS_DEFAULT                                     equ     0H
GPS_HANDLERPROPERTIESONLY                       equ     01H
GPS_READWRITE                                   equ     02H
GPS_TEMPORARY                                   equ     04H
GPS_FASTPROPERTIESONLY                          equ     08H
GPS_OPENSLOWITEM                                equ     010H
GPS_DELAYCREATION                               equ     020H
GPS_BESTEFFORT                                  equ     040H
GPS_NO_OPLOCK                                   equ     080H
GPS_PREFERQUERYPROPERTIES                       equ     0100H
GPS_MASK_VALID                                  equ     01FFH
GPS_EXTRINSICPROPERTIES                         equ     00000200H
GPS_EXTRINSICPROPERTIESONLY                     equ     00000400H

DOGIF_DEFAULT                                   equ     0000H
DOGIF_TRAVERSE_LINK                             equ     0001H
DOGIF_NO_HDROP                                  equ     0002H
DOGIF_NO_URL                                    equ     0004H
DOGIF_ONLY_IF_ONE                               equ     0008H

KF_FLAG_SIMPLE_IDLIST                           equ     00000100H
KF_FLAG_NOT_PARENT_RELATIVE                     equ     00000200H
KF_FLAG_DEFAULT_PATH                            equ     00000400H
KF_FLAG_INIT                                    equ     00000800H
KF_FLAG_NO_ALIAS                                equ     00001000H
KF_FLAG_DONT_UNEXPAND                           equ     00002000H
KF_FLAG_DONT_VERIFY                             equ     00004000H
KF_FLAG_CREATE                                  equ     00008000H
KF_FLAG_NO_APPCONTAINER_REDIRECTION             equ     00010000H
KF_FLAG_ALIAS_ONLY                              equ     80000000H

LMD_DEFAULT                                     equ     00000000H
LMD_ALLOWUNINDEXABLENETWORKLOCATIONS            equ     00000001H

;======================================== Functions ======================================;
if defined APP_WIN64
    import shell32,\
    AppCompat_RunDLLW,'AppCompat_RunDLLW',\
    AssocCreateForClasses,'AssocCreateForClasses',\
    AssocGetDetailsOfPropKey,'AssocGetDetailsOfPropKey',\
    CallCPLEntry16,'CallCPLEntry16',\
    CDefFolderMenu_Create,'CDefFolderMenu_Create',\
    CDefFolderMenu_Create2,'CDefFolderMenu_Create2',\
    CheckEscapesA,'CheckEscapesA',\
    CheckEscapesW,'CheckEscapesW',\
    CIDLData_CreateFromIDArray,'CIDLData_CreateFromIDArray',\
    CommandLineToArgvW,'CommandLineToArgvW',\
    Control_FillCache_RunDLLA,'Control_FillCache_RunDLLA',\
    Control_FillCache_RunDLLW,'Control_FillCache_RunDLLW',\
    Control_RunDLLA,'Control_RunDLLA',\
    Control_RunDLLAsUserW,'Control_RunDLLAsUserW',\
    Control_RunDLLW,'Control_RunDLLW',\
    DAD_AutoScroll,'DAD_AutoScroll',\
    DAD_DragEnterEx,'DAD_DragEnterEx',\
    DAD_DragEnterEx2,'DAD_DragEnterEx2',\
    DAD_DragLeave,'DAD_DragLeave',\
    DAD_DragMove,'DAD_DragMove',\
    DAD_SetDragImage,'DAD_SetDragImage',\
    DAD_ShowDragImage,'DAD_ShowDragImage',\
    DllCanUnloadNow,'DllCanUnloadNow',\
    DllGetActivationFactory,'DllGetActivationFactory',\
    DllGetVersion,'DllGetVersion',\
    DllRegisterServer,'DllRegisterServer',\
    DllUnregisterServer,'DllUnregisterServer',\
    DoEnvironmentSubstA,'DoEnvironmentSubstA',\
    DoEnvironmentSubstW,'DoEnvironmentSubstW',\
    DragAcceptFiles,'DragAcceptFiles',\
    DragFinish,'DragFinish',\
    DragQueryFileA,'DragQueryFileA',\
    DragQueryFileAorW,'DragQueryFileAorW',\
    DragQueryFileW,'DragQueryFileW',\
    DragQueryPoint,'DragQueryPoint',\
    DriveType,'DriveType',\
    DuplicateIcon,'DuplicateIcon',\
    ExtractAssociatedIconA,'ExtractAssociatedIconA',\
    ExtractAssociatedIconExA,'ExtractAssociatedIconExA',\
    ExtractAssociatedIconExW,'ExtractAssociatedIconExW',\
    ExtractAssociatedIconW,'ExtractAssociatedIconW',\
    ExtractIconA,'ExtractIconA',\
    ExtractIconExA,'ExtractIconExA',\
    ExtractIconExW,'ExtractIconExW',\
    ExtractIconResInfoA,'ExtractIconResInfoA',\
    ExtractIconResInfoW,'ExtractIconResInfoW',\
    ExtractIconW,'ExtractIconW',\
    ExtractVersionResource16W,'ExtractVersionResource16W',\
    FindExecutableA,'FindExecutableA',\
    FindExecutableW,'FindExecutableW',\
    FindExeDlgProc,'FindExeDlgProc',\
    FreeIconList,'FreeIconList',\
    GetCurrentProcessExplicitAppUserModelID,'GetCurrentProcessExplicitAppUserModelID',\
    GetFileNameFromBrowse,'GetFileNameFromBrowse',\
    ILAppendID,'ILAppendID',\
    ILClone,'ILClone',\
    ILCloneFirst,'ILCloneFirst',\
    ILCombine,'ILCombine',\
    ILCreateFromPathA,'ILCreateFromPathA',\
    ILCreateFromPathW,'ILCreateFromPathW',\
    ILFindChild,'ILFindChild',\
    ILFindLastID,'ILFindLastID',\
    ILFree,'ILFree',\
    ILGetNext,'ILGetNext',\
    ILGetSize,'ILGetSize',\
    ILIsEqual,'ILIsEqual',\
    ILIsParent,'ILIsParent',\
    ILLoadFromStream,'ILLoadFromStream',\
    ILLoadFromStreamEx,'ILLoadFromStreamEx',\
    ILRemoveLastID,'ILRemoveLastID',\
    ILSaveToStream,'ILSaveToStream',\
    InitNetworkAddressControl,'InitNetworkAddressControl',\
    InternalExtractIconListA,'InternalExtractIconListA',\
    InternalExtractIconListW,'InternalExtractIconListW',\
    IsLFNDrive,'IsLFNDrive',\
    IsLFNDriveA,'IsLFNDriveA',\
    IsLFNDriveW,'IsLFNDriveW',\
    IsNetDrive,'IsNetDrive',\
    IsProcessAnExplorer,'IsProcessAnExplorer',\
    IsUserAnAdmin,'IsUserAnAdmin',\
    OpenAs_RunDLLA,'OpenAs_RunDLLA',\
    OpenAs_RunDLLW,'OpenAs_RunDLLW',\
    OpenRegStream,'OpenRegStream',\
    Options_RunDLLA,'Options_RunDLLA',\
    Options_RunDLLW,'Options_RunDLLW',\
    PathCleanupSpec,'PathCleanupSpec',\
    PathGetShortPath,'PathGetShortPath',\
    PathIsExe,'PathIsExe',\
    PathIsSlowA,'PathIsSlowA',\
    PathIsSlowW,'PathIsSlowW',\
    PathMakeUniqueName,'PathMakeUniqueName',\
    PathProcessCommand,'PathProcessCommand',\
    PathResolve,'PathResolve',\
    PathYetAnotherMakeUniqueName,'PathYetAnotherMakeUniqueName',\
    PickIconDlg,'PickIconDlg',\
    PifMgr_CloseProperties,'PifMgr_CloseProperties',\
    PifMgr_GetProperties,'PifMgr_GetProperties',\
    PifMgr_OpenProperties,'PifMgr_OpenProperties',\
    PifMgr_SetProperties,'PifMgr_SetProperties',\
    ReadCabinetState,'ReadCabinetState',\
    RealDriveType,'RealDriveType',\
    RealShellExecuteA,'RealShellExecuteA',\
    RealShellExecuteExA,'RealShellExecuteExA',\
    RealShellExecuteExW,'RealShellExecuteExW',\
    RealShellExecuteW,'RealShellExecuteW',\
    RegenerateUserEnvironment,'RegenerateUserEnvironment',\
    RestartDialog,'RestartDialog',\
    RestartDialogEx,'RestartDialogEx',\
    RunAsNewUser_RunDLLW,'RunAsNewUser_RunDLLW',\
    SetCurrentProcessExplicitAppUserModelID,'SetCurrentProcessExplicitAppUserModelID',\
    SHAddDefaultPropertiesByExt,'SHAddDefaultPropertiesByExt',\
    SHAddFromPropSheetExtArray,'SHAddFromPropSheetExtArray',\
    SHAddToRecentDocs,'SHAddToRecentDocs',\
    SHAlloc,'SHAlloc',\
    SHAllocShared,'SHAllocShared',\
    SHAppBarMessage,'SHAppBarMessage',\
    SHAssocEnumHandlers,'SHAssocEnumHandlers',\
    SHAssocEnumHandlersForProtocolByApplication,'SHAssocEnumHandlersForProtocolByApplication',\
    SHBindToFolderIDListParent,'SHBindToFolderIDListParent',\
    SHBindToFolderIDListParentEx,'SHBindToFolderIDListParentEx',\
    SHBindToObject,'SHBindToObject',\
    SHBindToParent,'SHBindToParent',\
    SHBrowseForFolderA,'SHBrowseForFolderA',\
    SHBrowseForFolderW,'SHBrowseForFolderW',\
    SHChangeNotification_Lock,'SHChangeNotification_Lock',\
    SHChangeNotification_Unlock,'SHChangeNotification_Unlock',\
    SHChangeNotify,'SHChangeNotify',\
    SHChangeNotifyDeregister,'SHChangeNotifyDeregister',\
    SHChangeNotifyRegister,'SHChangeNotifyRegister',\
    SHChangeNotifyRegisterThread,'SHChangeNotifyRegisterThread',\
    SHChangeNotifySuspendResume,'SHChangeNotifySuspendResume',\
    SHCloneSpecialIDList,'SHCloneSpecialIDList',\
    SHCLSIDFromString,'SHCLSIDFromString',\
    SHCoCreateInstance,'SHCoCreateInstance',\
    SHCreateAssociationRegistration,'SHCreateAssociationRegistration',\
    SHCreateDataObject,'SHCreateDataObject',\
    SHCreateDefaultContextMenu,'SHCreateDefaultContextMenu',\
    SHCreateDefaultExtractIcon,'SHCreateDefaultExtractIcon',\
    SHCreateDefaultPropertiesOp,'SHCreateDefaultPropertiesOp',\
    SHCreateDirectory,'SHCreateDirectory',\
    SHCreateDirectoryExA,'SHCreateDirectoryExA',\
    SHCreateDirectoryExW,'SHCreateDirectoryExW',\
    SHCreateFileExtractIconW,'SHCreateFileExtractIconW',\
    SHCreateItemFromIDList,'SHCreateItemFromIDList',\
    SHCreateItemFromParsingName,'SHCreateItemFromParsingName',\
    SHCreateItemFromRelativeName,'SHCreateItemFromRelativeName',\
    SHCreateItemInKnownFolder,'SHCreateItemInKnownFolder',\
    SHCreateItemWithParent,'SHCreateItemWithParent',\
    SHCreateProcessAsUserW,'SHCreateProcessAsUserW',\
    SHCreatePropSheetExtArray,'SHCreatePropSheetExtArray',\
    SHCreateQueryCancelAutoPlayMoniker,'SHCreateQueryCancelAutoPlayMoniker',\
    SHCreateShellFolderView,'SHCreateShellFolderView',\
    SHCreateShellFolderViewEx,'SHCreateShellFolderViewEx',\
    SHCreateShellItem,'SHCreateShellItem',\
    SHCreateShellItemArray,'SHCreateShellItemArray',\
    SHCreateShellItemArrayFromDataObject,'SHCreateShellItemArrayFromDataObject',\
    SHCreateShellItemArrayFromIDLists,'SHCreateShellItemArrayFromIDLists',\
    SHCreateShellItemArrayFromShellItem,'SHCreateShellItemArrayFromShellItem',\
    SHCreateStdEnumFmtEtc,'SHCreateStdEnumFmtEtc',\
    SHDefExtractIconA,'SHDefExtractIconA',\
    SHDefExtractIconW,'SHDefExtractIconW',\
    SHDestroyPropSheetExtArray,'SHDestroyPropSheetExtArray',\
    SHDoDragDrop,'SHDoDragDrop',\
    SheChangeDirA,'SheChangeDirA',\
    SheChangeDirExA,'SheChangeDirExA',\
    SheChangeDirExW,'SheChangeDirExW',\
    SheChangeDirW,'SheChangeDirW',\
    SheFullPathA,'SheFullPathA',\
    SheFullPathW,'SheFullPathW',\
    SheGetCurDrive,'SheGetCurDrive',\
    SheGetDirA,'SheGetDirA',\
    SheGetDirExW,'SheGetDirExW',\
    SheGetDirW,'SheGetDirW',\
    SheGetPathOffsetW,'SheGetPathOffsetW',\
    Shell_GetCachedImageIndex,'Shell_GetCachedImageIndex',\
    Shell_GetCachedImageIndexA,'Shell_GetCachedImageIndexA',\
    Shell_GetCachedImageIndexW,'Shell_GetCachedImageIndexW',\
    Shell_GetImageLists,'Shell_GetImageLists',\
    Shell_MergeMenus,'Shell_MergeMenus',\
    Shell_NotifyIconA,'Shell_NotifyIconA',\
    Shell_NotifyIconGetRect,'Shell_NotifyIconGetRect',\
    Shell_NotifyIconW,'Shell_NotifyIconW',\
    ShellAboutA,'ShellAboutA',\
    ShellAboutW,'ShellAboutW',\
    ShellExec_RunDLLA,'ShellExec_RunDLLA',\
    ShellExec_RunDLLW,'ShellExec_RunDLLW',\
    ShellExecuteA,'ShellExecuteA',\
    ShellExecuteExA,'ShellExecuteExA',\
    ShellExecuteExW,'ShellExecuteExW',\
    ShellExecuteW,'ShellExecuteW',\
    ShellHookProc,'ShellHookProc',\
    ShellMessageBoxA,'ShellMessageBoxA',\
    ShellMessageBoxW,'ShellMessageBoxW',\
    SHEmptyRecycleBinA,'SHEmptyRecycleBinA',\
    SHEmptyRecycleBinW,'SHEmptyRecycleBinW',\
    SHEnableServiceObject,'SHEnableServiceObject',\
    SHEnumerateUnreadMailAccountsW,'SHEnumerateUnreadMailAccountsW',\
    SheRemoveQuotesA,'SheRemoveQuotesA',\
    SheRemoveQuotesW,'SheRemoveQuotesW',\
    SheSetCurDrive,'SheSetCurDrive',\
    SheShortenPathA,'SheShortenPathA',\
    SheShortenPathW,'SheShortenPathW',\
    SHEvaluateSystemCommandTemplate,'SHEvaluateSystemCommandTemplate',\
    SHExtractIconsW,'SHExtractIconsW',\
    SHFileOperationA,'SHFileOperationA',\
    SHFileOperationW,'SHFileOperationW',\
    SHFind_InitMenuPopup,'SHFind_InitMenuPopup',\
    SHFindFiles,'SHFindFiles',\
    SHFlushClipboard,'SHFlushClipboard',\
    SHFlushSFCache,'SHFlushSFCache',\
    SHFormatDrive,'SHFormatDrive',\
    SHFree,'SHFree',\
    SHFreeNameMappings,'SHFreeNameMappings',\
    SHFreeShared,'SHFreeShared',\
    SHGetAttributesFromDataObject,'SHGetAttributesFromDataObject',\
    SHGetDataFromIDListA,'SHGetDataFromIDListA',\
    SHGetDataFromIDListW,'SHGetDataFromIDListW',\
    SHGetDesktopFolder,'SHGetDesktopFolder',\
    SHGetDiskFreeSpaceA,'SHGetDiskFreeSpaceA',\
    SHGetDiskFreeSpaceExA,'SHGetDiskFreeSpaceExA',\
    SHGetDiskFreeSpaceExW,'SHGetDiskFreeSpaceExW',\
    SHGetDriveMedia,'SHGetDriveMedia',\
    SHGetFileInfoA,'SHGetFileInfoA',\
    SHGetFileInfoW,'SHGetFileInfoW',\
    SHGetFolderLocation,'SHGetFolderLocation',\
    SHGetFolderPathA,'SHGetFolderPathA',\
    SHGetFolderPathAndSubDirA,'SHGetFolderPathAndSubDirA',\
    SHGetFolderPathAndSubDirW,'SHGetFolderPathAndSubDirW',\
    SHGetFolderPathEx,'SHGetFolderPathEx',\
    SHGetFolderPathW,'SHGetFolderPathW',\
    SHGetIconOverlayIndexA,'SHGetIconOverlayIndexA',\
    SHGetIconOverlayIndexW,'SHGetIconOverlayIndexW',\
    SHGetIDListFromObject,'SHGetIDListFromObject',\
    SHGetImageList,'SHGetImageList',\
    SHGetInstanceExplorer,'SHGetInstanceExplorer',\
    SHGetItemFromDataObject,'SHGetItemFromDataObject',\
    SHGetItemFromObject,'SHGetItemFromObject',\
    SHGetKnownFolderIDList,'SHGetKnownFolderIDList',\
    SHGetKnownFolderItem,'SHGetKnownFolderItem',\
    SHGetKnownFolderPath,'SHGetKnownFolderPath',\
    SHGetLocalizedName,'SHGetLocalizedName',\
    SHGetMalloc,'SHGetMalloc',\
    SHGetNameFromIDList,'SHGetNameFromIDList',\
    SHGetNewLinkInfoA,'SHGetNewLinkInfoA',\
    SHGetNewLinkInfoW,'SHGetNewLinkInfoW',\
    SHGetPathFromIDListA,'SHGetPathFromIDListA',\
    SHGetPathFromIDListEx,'SHGetPathFromIDListEx',\
    SHGetPathFromIDListW,'SHGetPathFromIDListW',\
    SHGetPropertyStoreForWindow,'SHGetPropertyStoreForWindow',\
    SHGetPropertyStoreFromIDList,'SHGetPropertyStoreFromIDList',\
    SHGetPropertyStoreFromParsingName,'SHGetPropertyStoreFromParsingName',\
    SHGetRealIDL,'SHGetRealIDL',\
    SHGetSetFolderCustomSettings,'SHGetSetFolderCustomSettings',\
    SHGetSetFolderCustomSettingsW,'SHGetSetFolderCustomSettingsW',\
    SHGetSetSettings,'SHGetSetSettings',\
    SHGetSettings,'SHGetSettings',\
    SHGetShellStyleHInstance,'SHGetShellStyleHInstance',\
    SHGetSpecialFolderLocation,'SHGetSpecialFolderLocation',\
    SHGetSpecialFolderPathA,'SHGetSpecialFolderPathA',\
    SHGetSpecialFolderPathW,'SHGetSpecialFolderPathW',\
    SHGetStockIconInfo,'SHGetStockIconInfo',\
    SHGetTemporaryPropertyForItem,'SHGetTemporaryPropertyForItem',\
    SHGetUnreadMailCountW,'SHGetUnreadMailCountW',\
    SHHandleUpdateImage,'SHHandleUpdateImage',\
    SHHelpShortcuts_RunDLLA,'SHHelpShortcuts_RunDLLA',\
    SHHelpShortcuts_RunDLLW,'SHHelpShortcuts_RunDLLW',\
    SHILCreateFromPath,'SHILCreateFromPath',\
    SHInvokePrinterCommandA,'SHInvokePrinterCommandA',\
    SHInvokePrinterCommandW,'SHInvokePrinterCommandW',\
    SHIsFileAvailableOffline,'SHIsFileAvailableOffline',\
    SHLimitInputEdit,'SHLimitInputEdit',\
    SHLoadInProc,'SHLoadInProc',\
    SHLoadNonloadedIconOverlayIdentifiers,'SHLoadNonloadedIconOverlayIdentifiers',\
    SHLockShared,'SHLockShared',\
    SHMapIDListToImageListIndexAsync,'SHMapIDListToImageListIndexAsync',\
    SHMapPIDLToSystemImageListIndex,'SHMapPIDLToSystemImageListIndex',\
    SHMultiFileProperties,'SHMultiFileProperties',\
    SHObjectProperties,'SHObjectProperties',\
    SHOpenFolderAndSelectItems,'SHOpenFolderAndSelectItems',\
    SHOpenPropSheetW,'SHOpenPropSheetW',\
    SHOpenWithDialog,'SHOpenWithDialog',\
    SHParseDisplayName,'SHParseDisplayName',\
    SHPathPrepareForWriteA,'SHPathPrepareForWriteA',\
    SHPathPrepareForWriteW,'SHPathPrepareForWriteW',\
    SHPropStgCreate,'SHPropStgCreate',\
    SHPropStgReadMultiple,'SHPropStgReadMultiple',\
    SHPropStgWriteMultiple,'SHPropStgWriteMultiple',\
    SHQueryRecycleBinA,'SHQueryRecycleBinA',\
    SHQueryRecycleBinW,'SHQueryRecycleBinW',\
    SHQueryUserNotificationState,'SHQueryUserNotificationState',\
    SHRemoveLocalizedName,'SHRemoveLocalizedName',\
    SHReplaceFromPropSheetExtArray,'SHReplaceFromPropSheetExtArray',\
    SHResolveLibrary,'SHResolveLibrary',\
    SHRestricted,'SHRestricted',\
    SHRunControlPanel,'SHRunControlPanel',\
    SHSetDefaultProperties,'SHSetDefaultProperties',\
    SHSetFolderPathA,'SHSetFolderPathA',\
    SHSetFolderPathW,'SHSetFolderPathW',\
    SHSetInstanceExplorer,'SHSetInstanceExplorer',\
    SHSetKnownFolderPath,'SHSetKnownFolderPath',\
    SHSetLocalizedName,'SHSetLocalizedName',\
    SHSetTemporaryPropertyForItem,'SHSetTemporaryPropertyForItem',\
    SHSetUnreadMailCountW,'SHSetUnreadMailCountW',\
    SHShellFolderView_Message,'SHShellFolderView_Message',\
    SHShowManageLibraryUI,'SHShowManageLibraryUI',\
    SHSimpleIDListFromPath,'SHSimpleIDListFromPath',\
    SHStartNetConnectionDialogW,'SHStartNetConnectionDialogW',\
    SHTestTokenMembership,'SHTestTokenMembership',\
    SHUnlockShared,'SHLockShared',\
    SHUpdateImageA,'SHUpdateImageA',\
    SHUpdateImageW,'SHUpdateImageW',\
    SHUpdateRecycleBinIcon,'SHUpdateRecycleBinIcon',\
    SHValidateUNC,'SHValidateUNC',\
    SignalFileOpen,'SignalFileOpen',\
    StgMakeUniqueName,'StgMakeUniqueName',\
    StrChrA,'StrChrA',\
    StrChrIA,'StrChrIA',\
    StrChrIW,'StrChrIW',\
    StrChrW,'StrChrW',\
    StrCmpNA,'StrCmpNA',\
    StrCmpNIA,'StrCmpNIA',\
    StrCmpNIW,'StrCmpNIW',\
    StrCmpNW,'StrCmpNW',\
    StrNCmpA,'StrNCmpA',\
    StrNCmpIA,'StrNCmpIA',\
    StrNCmpIW,'StrNCmpIW',\
    StrNCmpW,'StrNCmpW',\
    StrRChrA,'StrRChrA',\
    StrRChrIA,'StrRChrIA',\
    StrRChrIW,'StrRChrIW',\
    StrRChrW,'StrRChrW',\
    StrRStrA,'StrRStrA',\
    StrRStrIA,'StrRStrIA',\
    StrRStrIW,'StrRStrIW',\
    StrRStrW,'StrRStrW',\
    StrStrA,'StrStrA',\
    StrStrIA,'StrStrIA',\
    StrStrIW,'StrStrIW',\
    StrStrW,'StrStrW',\
    WaitForExplorerRestartW,'WaitForExplorerRestartW',\
    Win32DeleteFile,'Win32DeleteFile',\
    WOWShellExecute,'WOWShellExecute',\
    WriteCabinetState,'WriteCabinetState'
else
    import shell32,\
    AppCompat_RunDLLW,'AppCompat_RunDLLW',\
    AssocCreateForClasses,'AssocCreateForClasses',\
    AssocGetDetailsOfPropKey,'AssocGetDetailsOfPropKey',\
    CallCPLEntry16,'CallCPLEntry16',\
    CDefFolderMenu_Create,'CDefFolderMenu_Create',\
    CDefFolderMenu_Create2,'CDefFolderMenu_Create2',\
    CheckEscapesA,'CheckEscapesA',\
    CheckEscapesW,'CheckEscapesW',\
    CIDLData_CreateFromIDArray,'CIDLData_CreateFromIDArray',\
    CommandLineToArgvW,'CommandLineToArgvW',\
    Control_FillCache_RunDLLA,'Control_FillCache_RunDLLA',\
    Control_FillCache_RunDLLW,'Control_FillCache_RunDLLW',\
    Control_RunDLLAsUserW,'Control_RunDLLAsUserW',\
    DAD_AutoScroll,'DAD_AutoScroll',\
    DAD_DragEnterEx,'DAD_DragEnterEx',\
    DAD_DragEnterEx2,'DAD_DragEnterEx2',\
    DAD_DragLeave,'DAD_DragLeave',\
    DAD_DragMove,'DAD_DragMove',\
    DAD_SetDragImage,'DAD_SetDragImage',\
    DAD_ShowDragImage,'DAD_ShowDragImage',\
    DllCanUnloadNow,'DllCanUnloadNow',\
    DllGetActivationFactory,'DllGetActivationFactory',\
    DllGetVersion,'DllGetVersion',\
    DllRegisterServer,'DllRegisterServer',\
    DllUnregisterServer,'DllUnregisterServer',\
    DoEnvironmentSubstA,'DoEnvironmentSubstA',\
    DoEnvironmentSubstW,'DoEnvironmentSubstW',\
    DragAcceptFiles,'DragAcceptFiles',\
    DragFinish,'DragFinish',\
    DragQueryFileA,'DragQueryFileA',\
    DragQueryFileAorW,'DragQueryFileAorW',\
    DragQueryFileW,'DragQueryFileW',\
    DragQueryPoint,'DragQueryPoint',\
    DriveType,'DriveType',\
    DuplicateIcon,'DuplicateIcon',\
    ExtractAssociatedIconA,'ExtractAssociatedIconA',\
    ExtractAssociatedIconExA,'ExtractAssociatedIconExA',\
    ExtractAssociatedIconExW,'ExtractAssociatedIconExW',\
    ExtractAssociatedIconW,'ExtractAssociatedIconW',\
    ExtractIconA,'ExtractIconA',\
    ExtractIconExA,'ExtractIconExA',\
    ExtractIconExW,'ExtractIconExW',\
    ExtractIconResInfoA,'ExtractIconResInfoA',\
    ExtractIconResInfoW,'ExtractIconResInfoW',\
    ExtractIconW,'ExtractIconW',\
    ExtractVersionResource16W,'ExtractVersionResource16W',\
    FindExecutableA,'FindExecutableA',\
    FindExecutableW,'FindExecutableW',\
    FindExeDlgProc,'FindExeDlgProc',\
    FreeIconList,'FreeIconList',\
    GetCurrentProcessExplicitAppUserModelID,'GetCurrentProcessExplicitAppUserModelID',\
    GetFileNameFromBrowse,'GetFileNameFromBrowse',\
    ILAppendID,'ILAppendID',\
    ILClone,'ILClone',\
    ILCloneFirst,'ILCloneFirst',\
    ILCombine,'ILCombine',\
    ILCreateFromPathA,'ILCreateFromPathA',\
    ILCreateFromPathW,'ILCreateFromPathW',\
    ILFindChild,'ILFindChild',\
    ILFindLastID,'ILFindLastID',\
    ILFree,'ILFree',\
    ILGetNext,'ILGetNext',\
    ILGetSize,'ILGetSize',\
    ILIsEqual,'ILIsEqual',\
    ILIsParent,'ILIsParent',\
    ILLoadFromStream,'ILLoadFromStream',\
    ILLoadFromStreamEx,'ILLoadFromStreamEx',\
    ILRemoveLastID,'ILRemoveLastID',\
    ILSaveToStream,'ILSaveToStream',\
    InitNetworkAddressControl,'InitNetworkAddressControl',\
    InternalExtractIconListA,'InternalExtractIconListA',\
    InternalExtractIconListW,'InternalExtractIconListW',\
    IsLFNDrive,'IsLFNDrive',\
    IsLFNDriveA,'IsLFNDriveA',\
    IsLFNDriveW,'IsLFNDriveW',\
    IsNetDrive,'IsNetDrive',\
    IsProcessAnExplorer,'IsProcessAnExplorer',\
    IsUserAnAdmin,'IsUserAnAdmin',\
    OpenRegStream,'OpenRegStream',\
    Options_RunDLLA,'Options_RunDLLA',\
    Options_RunDLLW,'Options_RunDLLW',\
    PathCleanupSpec,'PathCleanupSpec',\
    PathGetShortPath,'PathGetShortPath',\
    PathIsExe,'PathIsExe',\
    PathIsSlowA,'PathIsSlowA',\
    PathIsSlowW,'PathIsSlowW',\
    PathMakeUniqueName,'PathMakeUniqueName',\
    PathProcessCommand,'PathProcessCommand',\
    PathResolve,'PathResolve',\
    PathYetAnotherMakeUniqueName,'PathYetAnotherMakeUniqueName',\
    PickIconDlg,'PickIconDlg',\
    PifMgr_CloseProperties,'PifMgr_CloseProperties',\
    PifMgr_GetProperties,'PifMgr_GetProperties',\
    PifMgr_OpenProperties,'PifMgr_OpenProperties',\
    PifMgr_SetProperties,'PifMgr_SetProperties',\
    ReadCabinetState,'ReadCabinetState',\
    RealDriveType,'RealDriveType',\
    RealShellExecuteA,'RealShellExecuteA',\
    RealShellExecuteExA,'RealShellExecuteExA',\
    RealShellExecuteExW,'RealShellExecuteExW',\
    RealShellExecuteW,'RealShellExecuteW',\
    RegenerateUserEnvironment,'RegenerateUserEnvironment',\
    RestartDialog,'RestartDialog',\
    RestartDialogEx,'RestartDialogEx',\
    RunAsNewUser_RunDLLW,'RunAsNewUser_RunDLLW',\
    SetCurrentProcessExplicitAppUserModelID,'SetCurrentProcessExplicitAppUserModelID',\
    SHAddDefaultPropertiesByExt,'SHAddDefaultPropertiesByExt',\
    SHAddFromPropSheetExtArray,'SHAddFromPropSheetExtArray',\
    SHAddToRecentDocs,'SHAddToRecentDocs',\
    SHAlloc,'SHAlloc',\
    SHAllocShared,'SHAllocShared',\
    SHAppBarMessage,'SHAppBarMessage',\
    SHAssocEnumHandlers,'SHAssocEnumHandlers',\
    SHAssocEnumHandlersForProtocolByApplication,'SHAssocEnumHandlersForProtocolByApplication',\
    SHBindToFolderIDListParent,'SHBindToFolderIDListParent',\
    SHBindToFolderIDListParentEx,'SHBindToFolderIDListParentEx',\
    SHBindToObject,'SHBindToObject',\
    SHBindToParent,'SHBindToParent',\
    SHBrowseForFolderA,'SHBrowseForFolderA',\
    SHBrowseForFolderW,'SHBrowseForFolderW',\
    SHChangeNotification_Lock,'SHChangeNotification_Lock',\
    SHChangeNotification_Unlock,'SHChangeNotification_Unlock',\
    SHChangeNotify,'SHChangeNotify',\
    SHChangeNotifyDeregister,'SHChangeNotifyDeregister',\
    SHChangeNotifyRegister,'SHChangeNotifyRegister',\
    SHChangeNotifyRegisterThread,'SHChangeNotifyRegisterThread',\
    SHChangeNotifySuspendResume,'SHChangeNotifySuspendResume',\
    SHCloneSpecialIDList,'SHCloneSpecialIDList',\
    SHCLSIDFromString,'SHCLSIDFromString',\
    SHCoCreateInstance,'SHCoCreateInstance',\
    SHCreateAssociationRegistration,'SHCreateAssociationRegistration',\
    SHCreateDataObject,'SHCreateDataObject',\
    SHCreateDefaultContextMenu,'SHCreateDefaultContextMenu',\
    SHCreateDefaultExtractIcon,'SHCreateDefaultExtractIcon',\
    SHCreateDefaultPropertiesOp,'SHCreateDefaultPropertiesOp',\
    SHCreateDirectory,'SHCreateDirectory',\
    SHCreateDirectoryExA,'SHCreateDirectoryExA',\
    SHCreateDirectoryExW,'SHCreateDirectoryExW',\
    SHCreateFileExtractIconW,'SHCreateFileExtractIconW',\
    SHCreateItemFromIDList,'SHCreateItemFromIDList',\
    SHCreateItemFromParsingName,'SHCreateItemFromParsingName',\
    SHCreateItemFromRelativeName,'SHCreateItemFromRelativeName',\
    SHCreateItemInKnownFolder,'SHCreateItemInKnownFolder',\
    SHCreateItemWithParent,'SHCreateItemWithParent',\
    SHCreateProcessAsUserW,'SHCreateProcessAsUserW',\
    SHCreatePropSheetExtArray,'SHCreatePropSheetExtArray',\
    SHCreateQueryCancelAutoPlayMoniker,'SHCreateQueryCancelAutoPlayMoniker',\
    SHCreateShellFolderView,'SHCreateShellFolderView',\
    SHCreateShellFolderViewEx,'SHCreateShellFolderViewEx',\
    SHCreateShellItem,'SHCreateShellItem',\
    SHCreateShellItemArray,'SHCreateShellItemArray',\
    SHCreateShellItemArrayFromDataObject,'SHCreateShellItemArrayFromDataObject',\
    SHCreateShellItemArrayFromIDLists,'SHCreateShellItemArrayFromIDLists',\
    SHCreateShellItemArrayFromShellItem,'SHCreateShellItemArrayFromShellItem',\
    SHCreateStdEnumFmtEtc,'SHCreateStdEnumFmtEtc',\
    SHDefExtractIconA,'SHDefExtractIconA',\
    SHDefExtractIconW,'SHDefExtractIconW',\
    SHDestroyPropSheetExtArray,'SHDestroyPropSheetExtArray',\
    SHDoDragDrop,'SHDoDragDrop',\
    SheChangeDirA,'SheChangeDirA',\
    SheChangeDirExA,'SheChangeDirExA',\
    SheChangeDirExW,'SheChangeDirExW',\
    SheChangeDirW,'SheChangeDirW',\
    SheFullPathA,'SheFullPathA',\
    SheFullPathW,'SheFullPathW',\
    SheGetCurDrive,'SheGetCurDrive',\
    SheGetDirA,'SheGetDirA',\
    SheGetDirExW,'SheGetDirExW',\
    SheGetDirW,'SheGetDirW',\
    SheGetPathOffsetW,'SheGetPathOffsetW',\
    Shell_GetCachedImageIndex,'Shell_GetCachedImageIndex',\
    Shell_GetCachedImageIndexA,'Shell_GetCachedImageIndexA',\
    Shell_GetCachedImageIndexW,'Shell_GetCachedImageIndexW',\
    Shell_GetImageLists,'Shell_GetImageLists',\
    Shell_MergeMenus,'Shell_MergeMenus',\
    Shell_NotifyIconA,'Shell_NotifyIconA',\
    Shell_NotifyIconGetRect,'Shell_NotifyIconGetRect',\
    Shell_NotifyIconW,'Shell_NotifyIconW',\
    ShellAboutA,'ShellAboutA',\
    ShellAboutW,'ShellAboutW',\
    ShellExec_RunDLLA,'ShellExec_RunDLLA',\
    ShellExec_RunDLLW,'ShellExec_RunDLLW',\
    ShellExecuteA,'ShellExecuteA',\
    ShellExecuteExA,'ShellExecuteExA',\
    ShellExecuteExW,'ShellExecuteExW',\
    ShellExecuteW,'ShellExecuteW',\
    ShellHookProc,'ShellHookProc',\
    ShellMessageBoxA,'ShellMessageBoxA',\
    ShellMessageBoxW,'ShellMessageBoxW',\
    SHEmptyRecycleBinA,'SHEmptyRecycleBinA',\
    SHEmptyRecycleBinW,'SHEmptyRecycleBinW',\
    SHEnableServiceObject,'SHEnableServiceObject',\
    SHEnumerateUnreadMailAccountsW,'SHEnumerateUnreadMailAccountsW',\
    SheRemoveQuotesA,'SheRemoveQuotesA',\
    SheRemoveQuotesW,'SheRemoveQuotesW',\
    SheSetCurDrive,'SheSetCurDrive',\
    SheShortenPathA,'SheShortenPathA',\
    SheShortenPathW,'SheShortenPathW',\
    SHEvaluateSystemCommandTemplate,'SHEvaluateSystemCommandTemplate',\
    SHExtractIconsW,'SHExtractIconsW',\
    SHFileOperationA,'SHFileOperationA',\
    SHFileOperationW,'SHFileOperationW',\
    SHFind_InitMenuPopup,'SHFind_InitMenuPopup',\
    SHFindFiles,'SHFindFiles',\
    SHFlushClipboard,'SHFlushClipboard',\
    SHFlushSFCache,'SHFlushSFCache',\
    SHFormatDrive,'SHFormatDrive',\
    SHFree,'SHFree',\
    SHFreeNameMappings,'SHFreeNameMappings',\
    SHFreeShared,'SHFreeShared',\
    SHGetAttributesFromDataObject,'SHGetAttributesFromDataObject',\
    SHGetDataFromIDListA,'SHGetDataFromIDListA',\
    SHGetDataFromIDListW,'SHGetDataFromIDListW',\
    SHGetDesktopFolder,'SHGetDesktopFolder',\
    SHGetDiskFreeSpaceA,'SHGetDiskFreeSpaceA',\
    SHGetDiskFreeSpaceExA,'SHGetDiskFreeSpaceExA',\
    SHGetDiskFreeSpaceExW,'SHGetDiskFreeSpaceExW',\
    SHGetDriveMedia,'SHGetDriveMedia',\
    SHGetFileInfoA,'SHGetFileInfoA',\
    SHGetFileInfoW,'SHGetFileInfoW',\
    SHGetFolderLocation,'SHGetFolderLocation',\
    SHGetFolderPathA,'SHGetFolderPathA',\
    SHGetFolderPathAndSubDirA,'SHGetFolderPathAndSubDirA',\
    SHGetFolderPathAndSubDirW,'SHGetFolderPathAndSubDirW',\
    SHGetFolderPathEx,'SHGetFolderPathEx',\
    SHGetFolderPathW,'SHGetFolderPathW',\
    SHGetIconOverlayIndexA,'SHGetIconOverlayIndexA',\
    SHGetIconOverlayIndexW,'SHGetIconOverlayIndexW',\
    SHGetIDListFromObject,'SHGetIDListFromObject',\
    SHGetImageList,'SHGetImageList',\
    SHGetInstanceExplorer,'SHGetInstanceExplorer',\
    SHGetItemFromDataObject,'SHGetItemFromDataObject',\
    SHGetItemFromObject,'SHGetItemFromObject',\
    SHGetKnownFolderIDList,'SHGetKnownFolderIDList',\
    SHGetKnownFolderItem,'SHGetKnownFolderItem',\
    SHGetKnownFolderPath,'SHGetKnownFolderPath',\
    SHGetLocalizedName,'SHGetLocalizedName',\
    SHGetMalloc,'SHGetMalloc',\
    SHGetNameFromIDList,'SHGetNameFromIDList',\
    SHGetNewLinkInfoA,'SHGetNewLinkInfoA',\
    SHGetNewLinkInfoW,'SHGetNewLinkInfoW',\
    SHGetPathFromIDListA,'SHGetPathFromIDListA',\
    SHGetPathFromIDListEx,'SHGetPathFromIDListEx',\
    SHGetPathFromIDListW,'SHGetPathFromIDListW',\
    SHGetPropertyStoreForWindow,'SHGetPropertyStoreForWindow',\
    SHGetPropertyStoreFromIDList,'SHGetPropertyStoreFromIDList',\
    SHGetPropertyStoreFromParsingName,'SHGetPropertyStoreFromParsingName',\
    SHGetRealIDL,'SHGetRealIDL',\
    SHGetSetFolderCustomSettings,'SHGetSetFolderCustomSettings',\
    SHGetSetFolderCustomSettingsW,'SHGetSetFolderCustomSettingsW',\
    SHGetSetSettings,'SHGetSetSettings',\
    SHGetSettings,'SHGetSettings',\
    SHGetShellStyleHInstance,'SHGetShellStyleHInstance',\
    SHGetSpecialFolderLocation,'SHGetSpecialFolderLocation',\
    SHGetSpecialFolderPathA,'SHGetSpecialFolderPathA',\
    SHGetSpecialFolderPathW,'SHGetSpecialFolderPathW',\
    SHGetStockIconInfo,'SHGetStockIconInfo',\
    SHGetTemporaryPropertyForItem,'SHGetTemporaryPropertyForItem',\
    SHGetUnreadMailCountW,'SHGetUnreadMailCountW',\
    SHHandleUpdateImage,'SHHandleUpdateImage',\
    SHHelpShortcuts_RunDLLA,'SHHelpShortcuts_RunDLLA',\
    SHHelpShortcuts_RunDLLW,'SHHelpShortcuts_RunDLLW',\
    SHILCreateFromPath,'SHILCreateFromPath',\
    SHInvokePrinterCommandA,'SHInvokePrinterCommandA',\
    SHInvokePrinterCommandW,'SHInvokePrinterCommandW',\
    SHIsFileAvailableOffline,'SHIsFileAvailableOffline',\
    SHLimitInputEdit,'SHLimitInputEdit',\
    SHLoadInProc,'SHLoadInProc',\
    SHLoadNonloadedIconOverlayIdentifiers,'SHLoadNonloadedIconOverlayIdentifiers',\
    SHLockShared,'SHLockShared',\
    SHMapIDListToImageListIndexAsync,'SHMapIDListToImageListIndexAsync',\
    SHMapPIDLToSystemImageListIndex,'SHMapPIDLToSystemImageListIndex',\
    SHMultiFileProperties,'SHMultiFileProperties',\
    SHObjectProperties,'SHObjectProperties',\
    SHOpenFolderAndSelectItems,'SHOpenFolderAndSelectItems',\
    SHOpenPropSheetW,'SHOpenPropSheetW',\
    SHOpenWithDialog,'SHOpenWithDialog',\
    SHParseDisplayName,'SHParseDisplayName',\
    SHPathPrepareForWriteA,'SHPathPrepareForWriteA',\
    SHPathPrepareForWriteW,'SHPathPrepareForWriteW',\
    SHPropStgCreate,'SHPropStgCreate',\
    SHPropStgReadMultiple,'SHPropStgReadMultiple',\
    SHPropStgWriteMultiple,'SHPropStgWriteMultiple',\
    SHQueryRecycleBinA,'SHQueryRecycleBinA',\
    SHQueryRecycleBinW,'SHQueryRecycleBinW',\
    SHQueryUserNotificationState,'SHQueryUserNotificationState',\
    SHRemoveLocalizedName,'SHRemoveLocalizedName',\
    SHReplaceFromPropSheetExtArray,'SHReplaceFromPropSheetExtArray',\
    SHResolveLibrary,'SHResolveLibrary',\
    SHRestricted,'SHRestricted',\
    SHRunControlPanel,'SHRunControlPanel',\
    SHSetDefaultProperties,'SHSetDefaultProperties',\
    SHSetFolderPathA,'SHSetFolderPathA',\
    SHSetFolderPathW,'SHSetFolderPathW',\
    SHSetInstanceExplorer,'SHSetInstanceExplorer',\
    SHSetKnownFolderPath,'SHSetKnownFolderPath',\
    SHSetLocalizedName,'SHSetLocalizedName',\
    SHSetTemporaryPropertyForItem,'SHSetTemporaryPropertyForItem',\
    SHSetUnreadMailCountW,'SHSetUnreadMailCountW',\
    SHShellFolderView_Message,'SHShellFolderView_Message',\
    SHShowManageLibraryUI,'SHShowManageLibraryUI',\
    SHSimpleIDListFromPath,'SHSimpleIDListFromPath',\
    SHStartNetConnectionDialogW,'SHStartNetConnectionDialogW',\
    SHTestTokenMembership,'SHTestTokenMembership',\
    SHUnlockShared,'SHUnlockShared',\
    SHUpdateImageA,'SHUpdateImageA',\
    SHUpdateImageW,'SHUpdateImageW',\
    SHUpdateRecycleBinIcon,'SHUpdateRecycleBinIcon',\
    SHValidateUNC,'SHValidateUNC',\
    SignalFileOpen,'SignalFileOpen',\
    StgMakeUniqueName,'StgMakeUniqueName',\
    StrChrA,'StrChrA',\
    StrChrIA,'StrChrIA',\
    StrChrIW,'StrChrIW',\
    StrChrW,'StrChrW',\
    StrCmpNA,'StrCmpNA',\
    StrCmpNIA,'StrCmpNIA',\
    StrCmpNIW,'StrCmpNIW',\
    StrCmpNW,'StrCmpNW',\
    StrNCmpA,'StrNCmpA',\
    StrNCmpIA,'StrNCmpIA',\
    StrNCmpIW,'StrNCmpIW',\
    StrNCmpW,'StrNCmpW',\
    StrRChrA,'StrRChrA',\
    StrRChrIA,'StrRChrIA',\
    StrRChrIW,'StrRChrIW',\
    StrRChrW,'StrRChrW',\
    StrRStrA,'StrRStrA',\
    StrRStrIA,'StrRStrIA',\
    StrRStrIW,'StrRStrIW',\
    StrRStrW,'StrRStrW',\
    StrStrA,'StrStrA',\
    StrStrIA,'StrStrIA',\
    StrStrIW,'StrStrIW',\
    StrStrW,'StrStrW',\
    WaitForExplorerRestartW,'WaitForExplorerRestartW',\
    Win32DeleteFile,'Win32DeleteFile',\
    WOWShellExecute,'WOWShellExecute',\
    WriteCabinetState,'WriteCabinetState'
end if

api CheckEscapes,\
	Control_FillCache_RunDLL, \
	DoEnvironmentSubst,\
	DragQueryFile,\
	ExtractAssociatedIcon,\
	ExtractAssociatedIconEx,\
	ExtractIcon,\
	ExtractIconEx,\
	ExtractIconResInfo,\
	FindExecutable,\
	ILCreateFromPath,\
	InternalExtractIconList,\
	Options_RunDLL,\
	PathIsSlow,\
	RealShellExecute,\
	RealShellExecuteEx,\
	SHBrowseForFolder,\
	SHCreateDirectoryEx,\
	SheChangeDir,\
	SheChangeDirEx,\
	SheFullPath,\
	SheGetDir,\
	Shell_GetCachedImageIndex,\
	Shell_NotifyIcon,\
	ShellAbout,\
	ShellExec_RunDLL,\
	ShellExecute,\
	ShellExecuteEx,\
	ShellMessageBox,\
	SHEmptyRecycleBin,\
	SheRemoveQuotes,\
	SheShortenPath,\
	SHFileOperation,\
	SHGetDataFromIDList,\
	SHGetDiskFreeSpaceEx,\
	SHGetFileInfo,\
	SHGetFolderPath,\
	SHGetFolderPathAndSubDir,\
	SHGetIconOverlayIndex,\
	SHGetNewLinkInfo,\
	SHGetPathFromIDList,\
	SHGetSpecialFolderPath,\
	SHHelpShortcuts_RunDLL,\
	SHInvokePrinterCommand,\
	SHPathPrepareForWrite,\
	SHQueryRecycleBin,\
	SHSetFolderPath,\
	SHUpdateImage,\
	StrChr,\
	StrChrI,\
	StrCmpN,\
	StrCmpNI,\
	StrNCmp,\
	StrNCmpI,\
	StrRChr,\
	StrRChrI,\
	StrRStr,\
	StrRStrI,\
	StrStr,\
	StrStrI

end if ;SHELL32_INC
